#!/v/guest/sw/bin/perl -w

###############################################################################
##                                                                           ##
##    Copyright (c) 2010 by Steffen Beyer.                                   ##
##    All rights reserved.                                                   ##
##                                                                           ##
##    This program is free software; you can redistribute it                 ##
##    and/or modify it under the same terms as Perl itself.                  ##
##                                                                           ##
###############################################################################

use strict;

use lib
qw(
    /u/sb/sw/pkg/perl/lib/perl/5.12.0/amd64-freebsd
    /u/sb/sw/pkg/perl/lib/perl/5.12.0
    /u/sb/sw/pkg/perl/lib/perl/site_perl/5.12.0/amd64-freebsd
    /u/sb/sw/pkg/perl/lib/perl/site_perl/5.12.0
);

use Storable qw(lock_nstore lock_retrieve);

umask(022);

my($Time) = time() - 30 * 86400;
my($Date) = timestamp();
my($File) = 'data.bin';
my($Root) = '/u/sb/.www/volley';
my($Path) = 'backups';
my($Data) = {};

my($Source) = $Root . '/' . $File;

if (-f $Source)
{
    eval { $Data = lock_retrieve($Source); };
    die "can't lock_retrieve file <$Source>: $@\n" if $@;
}

my($Backup) = $Root   . '/' . $Path;
my($Target) = $Backup . '/' . $Date . '_' . $File;

unless (-e $Target)
{
    eval { lock_nstore($Data, $Target); };
    die "can't lock_nstore file <$Target>: $@\n" if $@;
    chmod(0444, $Target) or warn "can't chmod file <$Target>: $!";
    opendir(DIR, $Backup) or die "can't open dir <$Backup>: $!\n";
    while (defined($File = readdir(DIR)))
    {
        next if ($File =~ /^\./);
        $Target = $Backup . '/' . $File;
        if (-f $Target and ((stat($Target))[9]||~0) < $Time)
        {
            chmod(0644, $Target) or warn "can't chmod file <$Target>: $!";
            unlink($Target) or warn "can't unlink file <$Target>: $!\n";
        }
    }
    closedir(DIR) or die "can't close dir <$Backup>: $!\n";
}

sub timestamp
{
    my(@date) = (localtime())[5,4,3,2,1,0];
    $date[0] += 1900;
    $date[1]++;
    return sprintf("%04d_%02d_%02d_%02d_%02d_%02d", @date);
}

__END__

